config/routes.rb
Rails.application.routes.draw do
  resources :projects
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Reveal health status on /up that returns 200 if the app boots with no exceptions, otherwise 500.
  # Can be used by load balancers and uptime monitors to verify that the app is live.
  get "up" => "rails/health#show", as: :rails_health_check

  # Defines the root path route ("/")
  root "home#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/project.rb
class Project < ApplicationRecord
  after_update_commit {broadcast_update_to "projects"}
  after_destroy_commit {broadcast_remove_to "projects", target: "project_#{self.id}"}
  after_create_commit {broadcast_append_to "projects", target: "listing"}
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
  end
end

app/controllers/projects_controller.rb
class ProjectsController < ApplicationController
  before_action :set_project, only: %i[ show edit update destroy ]

  # GET /projects
  def index
    @projects = Project.all
  end

  # GET /projects/1
  def show
  end

  # GET /projects/new
  def new
    @project = Project.new
  end

  # GET /projects/1/edit
  def edit
  end

  # POST /projects
  def create
    @project = Project.new(project_params)
    respond_to do |format|
    if @project.save
      format.turbo_stream
      format.html {redirect_to @project, notice: "Project was successfully created."}
    else
      format.html {render :new, status: :unprocessable_entity}
    end
    end
  end

  # PATCH/PUT /projects/1
  def update
    respond_to do |format|
    if @project.update(project_params)
      format.turbo_stream
      format.html { redirect_to projects_url, notice: "Project was successfully updated.", status: :see_other}
    else
      format.html {render :edit, status: :unprocessable_entity}
    end
    end
  end

  # DELETE /projects/1
  def destroy
    @project.destroy!
    redirect_to projects_url, notice: "Project was successfully destroyed.", status: :see_other
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_project
      @project = Project.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def project_params
      params.require(:project).permit(:title)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/projects_helper.rb
module ProjectsHelper
end

app/views/home/index.html.erb
<div class="col-span-2">
  <ul role="list" class="divide-y divide-gray-200">
    <li class="py-4">
      <p class="text-2xl font-bold text-sky-500"><%= link_to "Project Test", projects_path %></p>
      <p class="text-sm ">Updating multiple topics via morphs</p>
    </li>
    <li class="py-4">
      <p class="text-2xl font-bold text-sky-500">Change Review Test</p>
      <p class="text-sm ">Updating multiple labels via morphs</p>
    </li>
  </ul>
</div>
<div class="col-span-4 px-5">
  <p class="text-6xl font-semibold">Morph Testing</p>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html class="h-full bg-white">
<head>
  <title>Element</title>
  <meta name="viewport" content="width=device-width,initial-scale=1">
  <%= csrf_meta_tags %>
  <%= csp_meta_tag %>
  <!-- Morphdom Start -->
  <%= turbo_refreshes_with method: :morph, scroll: :preserve   %>
  <%= content_for :head %>
  <!-- Morphdom End -->
  <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
  <%= javascript_include_tag "application", "data-turbo-track": "reload", type: "module" %>
</head>

<body class="h-full">
<div class="flex min-h-full flex-col">
  <header class="shrink-0 bg-gray-900">
    <div class="mx-auto flex h-16 max-w-7xl items-center justify-between px-4 sm:px-6 lg:px-8">
      <img class="h-8 w-auto" src="https://tailwindui.com/img/logos/mark.svg?color=blue&shade=500" alt="Your Company">
      <div class="flex items-center gap-x-8">
        <button type="button" class="-m-2.5 p-2.5 text-gray-400 hover:text-gray-300">
          <span class="sr-only">View notifications</span>
          <svg class="h-6 w-6" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" aria-hidden="true">
            <path stroke-linecap="round" stroke-linejoin="round" d="M14.857 17.082a23.848 23.848 0 005.454-1.31A8.967 8.967 0 0118 9.75v-.7V9A6 6 0 006 9v.75a8.967 8.967 0 01-2.312 6.022c1.733.64 3.56 1.085 5.455 1.31m5.714 0a24.255 24.255 0 01-5.714 0m5.714 0a3 3 0 11-5.714 0" />
          </svg>
        </button>
        <a href="#" class="-m-1.5 p-1.5">
          <span class="sr-only">Your profile</span>
          <img class="h-8 w-8 rounded-full bg-gray-800" src="https://images.unsplash.com/photo-1472099645785-5658abf4ff4e?ixlib=rb-1.2.1&ixid=eyJhcHBfaWQiOjEyMDd9&auto=format&fit=facearea&facepad=2&w=256&h=256&q=80" alt="">
        </a>
      </div>
    </div>
  </header>

  <!-- 3 column wrapper -->
  <div class="mx-auto w-full max-w-7xl grow lg:flex xl:px-2">
    <%= yield %>
  </div>
</div>
</body>
</html>

app/views/projects/_form.html.erb
<%= form_with(model: project) do |form| %>
  <% if project.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(project.errors.count, "error") %> prohibited this project from being saved:</h2>

      <ul>
        <% project.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
  <div class="mt-2 grid grid-cols-1 gap-x-6 gap-y-2 sm:grid-cols-6">
    <div class="col-span-3">
      <%= form.label :title, class: "block text-sm font-medium leading-6 text-gray-900" %>
      <%= form.text_field :title, class: "block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6" %>
    </div>
    <div class="col-span-full">
    </div>
    <div class="col-span-2 gap-x-6">
      <%= link_to "Cancel", projects_path, data: {turbo_frame: "_top"}, class: "font-medium text-blue-600 dark:text-blue-500 hover:underline mr-5" %>
      <%= form.submit class: "text-white bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm px-2.5 py-1.5 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800" %>
    </div>
  </div>
<% end %>

app/views/projects/_project.html.erb
<%= turbo_frame_tag(dom_id(project))  do %>
  <li class="relative flex justify-between gap-x-6 py-2">
    <div class="flex min-w-0 gap-x-4">
      <div class="min-w-0 flex-auto">
        <p class="text-sm font-semibold leading-6 text-gray-900">
            <!-- The content of your list item. -->
            <%= link_to project.title, project_path(project), data: {turbo_frame: "detail"} %>
        </p>
      </div>
    </div>
  </li>
<% end %>

app/views/projects/create.turbo_stream.erb
<%= turbo_stream.append "listing" do %>
  <%= render partial: "project", object: @project %>
<% end %>

app/views/projects/edit.html.erb
<div class="col-span-6">
  <%= turbo_frame_tag "detail" do %>

    <h2 class="py-5 text-3xl font-semibold leading-7 text-gray-900">Edit project</h2>

    <%= render "form", project: @project, data: {turbo_frame: "navigation"} %>
  <% end %>
</div>

app/views/projects/index.html.erb
<%= turbo_stream_from "projects" %>
<!-- Left sidebar & main wrapper -->
<div class="flex-1 xl:flex">
  <div class="border-b border-gray-200 px-4 py-6 sm:px-6 lg:pl-8 xl:w-2/6 xl:shrink-0 xl:border-b-0 xl:border-r xl:pl-6">
    <%= link_to "New project", new_project_path, data: {turbo_frame: "detail"}, class: "font-medium text-xl text-blue-600 dark:text-blue-500 hover:underline py-4"   %>
    <ul>
      <%= turbo_frame_tag "listing" do %>
        <%= render partial: "projects/project", collection: @projects %>
      <% end %>
    </ul>


  </div>

  <div class="px-4 py-6 sm:px-6 lg:pl-8 xl:flex-1 xl:pl-6">
    <!-- Main area -->
    <%= turbo_frame_tag "detail" do %>
      <p style="color: green"><%= notice %></p>
    <% end %>
  </div>
</div>

app/views/projects/new.html.erb
<div>
  <%= turbo_frame_tag "detail" do %>
    <h2 class="py-5 text-3xl font-semibold leading-7 text-gray-900">New project</h2>

    <%= render "form", project: @project %>
  <% end %>
</div>

app/views/projects/show.html.erb
<div>
  <%= turbo_frame_tag "detail" do %>
    <p style="color: green"><%= notice %></p>
    <h2 class="py-5 text-3xl font-semibold leading-7 text-gray-900">Project Detail</h2>

    <%= render @project %>

    <div>
      <%= link_to "Edit this project", edit_project_path(@project), data: {turbo_frame: "detail"} %> |


      <%= button_to "Destroy this project",  @project, data: {turbo_frame: "_top"}, method: :delete %>
    </div>

  <% end %>
</div>

app/views/projects/update.turbo_stream.erb
<%= turbo_stream.update "project_#{@project.id}" do %>
  <%= render partial: "projects/project", locals: {project: @project} %>
<% end %>